<?php
include "CreepTD.php";

$mapfile = CREEPTD_BASE."/map_test.map";

echo "<pre>";
try {
    $valid = creeptd_validate_mapfile($mapfile, $warnings);
    echo "<b>Valid:</b ".(($valid) ? "yes" : "no")."\n";
    echo "<b>Warnings:</b>";
    if (empty($warnings)) {
        echo " none\n";
    } else {
        echo "\n";
        foreach ($warnings as $warning) {
            echo "- ".htmlspecialchars($warning)."\n";
        }
    }
    $map = CreepTD::parseMapfile($mapfile, $warnings, $message);
    if ($valid) {
        echo "<b>Map name:</b> ".htmlspecialchars($map->getName())."\n";
        echo "<b>Author:</b> ".htmlspecialchars($map->getAuthor())."\n";
        echo "<b>Validation message:</b> ".htmlspecialchars($message)."\n";
        echo "<b>Size:</b> ".$map->getWidth()."x".$map->getHeight()."\n";
        // $map->getPath() contains the full traversable path tree
        echo "\n";
        echo "<b>Parsed segments:</b>\n";
        foreach ($map->getPath()->getSegments() as $segment) {
            echo "  [".htmlspecialchars($segment->compile())."] depth=".$segment->getDepth()."\n";
        }
        echo "<b>Holyland:</b> "; print_r($map->getHolyland());
        echo "<b>Compiler output:</b>\n";
        $compiledMap = $map->compile();
        echo htmlspecialchars($compiledMap);
        echo "\n<b>Re-Validation:</b> ".((creeptd_validate_mapdata($compiledMap)) ? "ok" : "failed")."\r\n";
    }
} catch (Exception $ex) {
    echo "Unable to parse map: ".htmlspecialchars($ex)."\n";
}
echo "</pre>";
?>